function asccode(STRING,  chstr) {
	chstr = " !\"#$%&'()*+,-./0123456789:;<=>?"
	chstr = chstr "@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_"
	chstr = chstr " abcdefghijklmnopqrstuvwxyz{|}~ "
	return index(chstr,STRING)+31
}

BEGIN {
	labelcnt = 1
	linecnt = 1
}

{

# Rg폜
	gsub(/'.*/,"'")

# ϐQɂ
	gsub(/NFAD/,"NF")
	gsub(/FAD/,"FD")
	gsub(/EAD/,"ED")
	gsub(/PAGE\.NO/,"PG")
	gsub(/GDR/,"GR")
	gsub(/GNO/,"GN")
	gsub(/BGMM/,"BM")
	gsub(/BGMN/,"BN")
	gsub(/BGXX/,"BX")
	gsub(/GST/,"GS")
	gsub(/SST/,"SS")
	gsub(/WASA/,"WS")
	gsub(/MVA/,"VA")
	gsub(/MVE/,"VE")
	gsub(/MOB/,"OB")
	gsub(/VSB/,"SB")
	gsub(/VAR/,"AR")
	gsub(/PUX/,"UX")
	gsub(/COM\.TOP\.ADD/,"CD")
	gsub(/VSM/,"SM")
	gsub(/SE\.P/,"SP")
	gsub(/SE\.A/,"SA")
	gsub(/SE\.L/,"SL")
	gsub(/SE\$/,"SL$")
	gsub(/POSE/,"PE")
	gsub(/SPOS/,"PS")
	gsub(/FRONT/,"FR")
	gsub(/ANS/,"AN")
	gsub(/VNO/,"VN")
	gsub(/ONO/,"OO")
	gsub(/NVA/,"NV")
	gsub(/DISK\(/,"DS(")
	gsub(/PDI/,"PD")
	gsub(/LNN/,"NN")
	gsub(/GDX/,"GX")

# R}h̕ύXȂ
	gsub(/WRITE/,"PRINT")
	gsub(/POLL/,"VIEW")
	gsub(/COLOR */,"&9+")
	gsub(/STATUS SET */,"WINDOW #")
	gsub(/STATUS CALL */,"WINDOW ")
	gsub(/STATUS\(/,"WINDOW(")
	gsub(/CLS *3/,"CLS")
	gsub(/DEFINT *A-Z:*/,"")

# &H8000` ̏
	gsub(/&H[8-9A-F][0-9A-F][0-9A-F][0-9A-F]/,"&+65536")

# LINȄ
	while (match($0,/LINE/) != 0) {
		ln1 = substr($0,1,RSTART-1)
		ln2 = substr($0,RSTART)
		sub(/LINE/,"@@LNDMY@@",ln2)
		sub(/,/,"@@DUMMY@@",ln2)
		sub(/,/,"@@DUMMY@@",ln2)
		sub(/,/,",9+",ln2)
		gsub(/@@DUMMY@@/,"/2,",ln2)
		$0 = ln1 ln2
	}
	gsub(/@@LNDMY@@/,"LINE")

# LOCATȄ
	while (match($0,/LOCATE */) != 0) {
		ln1 = substr($0,1,RSTART-1)
		ln2 = substr($0,RSTART+RLENGTH)

		lne = match(ln2,/:/)
		lnc = match(ln2,/,/)
		if (lnc == 0 || (lne != 0 && lnc > lne) ) {
			if (match(ln2,/:/) != 0) {
				lnx = substr(ln2,1,RSTART-1)
				ln2 = substr(ln2,RSTART)
			} else {
				lnx = ln2
				ln2 = ""
			}
			lny = "CSRLIN"
		} else {
			match(ln2,/,/)
			lnx = substr(ln2,1,RSTART-1)
			ln2 = substr(ln2,RSTART+RLENGTH)
			if (match(ln2,/:/) != 0) {
				lny = substr(ln2,1,RSTART-1)
				ln2 = substr(ln2,RSTART)
			} else {
				lny = ln2
				ln2 = ""
			}
		}
		$0 = ln1 "ZX=" lnx ":ZY=" lny ":GOSUB 10000" ln2
	}


# RETURN sԍ̏
	gsub(/GOSUB *\*BETA\.OUT/,"&:ON RR GOTO 130,6000,100")
	gsub(/RETURN *130/,"RR=1:RETURN")
	gsub(/RETURN *\*LOAD\./,"RR=2:RETURN")
	gsub(/RETURN *\*MAIN\.LOOP/,"RR=3:RETURN")
	if ($1 == "4010") {
		gsub(/RETURN/,"RR=0:RETURN")
	}


# ʕύX
	gsub(/SWAP UP,GD/,"XX=UP:UP=GD:GD=XX")

	if ($1 == 120) {
		sub(/CVI\(CHR\$\(WINDOW\(0\)\)\+CHR\$\(WINDOW\(1\)\)\)/,"WINDOW(0)+256*WINDOW(1)")
	}
	if ($1 == 310) {
		sub(/MATA/,"MA")
	}
	if ($1 == 320) {
		sub(/CALL MATA\(/,"CMD MA,4,2,")
		sub(/AR\(0\)/,"@@@")
		sub(/\)/,"")
		sub(/@@@/,"AR(0)")
	}
	if ($1 == 660) {
		sub(/CVI\(/,"")
		gsub(/CHR\$\(/,"")
		sub(/\)\)\)/,")")
		sub(/\)\)\+/,")+256*")
	}
	if ($1 == 810) {
		sub(/CALI/,"CA")
		sub(/CALL CALI\(/,"CMD CA,5,2,")
		sub(/AR\(0\)/,"@@@")
		sub(/\)/,"")
		sub(/@@@/,"AR(0)")
	}
	if ($1 == 1010) {
		sub(/CALL EPASS\(/,"CMD EP,4,0,")
		sub(/AR\(0\)/,"@@@")
		sub(/\)/,"")
		sub(/@@@/,"AR(0)")
	}
	if ($1 == 1220) {
		sub(/CALL SEL\(/,"CMD SE,4,2,")
		sub(/SL\$\(SP\)/,"@@@")
		sub(/\)/,"")
		sub(/@@@/,"SL$(SP)")
	}
	if ($1 == 1630) {
		sub(/KAKKO/,"KA")
		sub(/CALL KAKKO\(/,"CMD KA,4,0,")
		sub(/AR\(0\)/,"@@@")
		sub(/\)/,"")
		sub(/@@@/,"AR(0)")
	}
	if ($1 == 1810) {
		sub(/CVI\(CHR\$\(A\)\+CHR\$\(GD\)\)/,"A+256*GD")
	}
	if ($1 == "2020") {
		sub(/ /," EXEC \\&H0123:")
	}
	if ($1 == "2070") {
		$0 = $1 " PK=KEY(0)"
	}
	if ($1 == "2080") {
		gsub(/IF PK AND 1/,"IF PK=30")
	}
	if ($1 == "2090") {
		gsub(/IF PK AND 2/,"IF PK=31")
	}
	if ($1 == "2100") {
		gsub(/IF PK AND 8/,"IF PK=28")
	}
	if ($1 == "2110") {
		gsub(/IF PK AND 4/,"IF PK=29")
	}
	if ($1 == "2120") {
		gsub(/IF PK AND 16/,"IF PK=13 OR PK=32")
	}
	if ($1 == "2130") {
		gsub(/IF PK AND 32/,"IF (PK=12 OR PK=27)")
	}
	if ($1 >= 2220 && $1 <= 2300) {
		$0 = $1 " REM"
	}
	if ($1 == 2810) {
		sub(/CLOSE/,"CLOSE #1")
		sub(/SS\(PG\)\\256/,"INT(SS(PG)/256)")
	}
	if ($1 == 2820) {
		sub(/POKE.*&HC3:/,"GOSUB 12300:")
	}
	if ($1 == 2830) {
		$0 = $1 " IF KEY(0)<>0 THEN 2830"
	}
	if ($1 == 2832) {
		$0 = $1 " IF KEY(0)=0 THEN 2832"
	}
	if ($1 == 2850) {
		$0 = $1 " REM"
	}
	if ($1 == 3320) {
		sub(/GS\(GD-1\)\\256/,"INT(GS(GD-1)/256)")
	}
	if ($1 == 3340) {
		gsub(/BEEP/,"PRINT CHR$(7)")
	}
	if ($1 == 3390) {
		$0 = $1 " OPEN PA$ FOR INPUT AS#2:WINDOW #2:WINDOW GN:SET 9+UP:CLOSE #2"
	}
	if ($1 == 4520) {
		$0 = $1 " GOSUB 11000"
	}
	if ($1 == 5001) {
		$0 = $1 " CLEAR 50,&HA000:SCREEN 1,1,1:CLS:CONSOLE 16,4,0,0:SCREEN 1,2,2"
	}
	if ($1 == 5010) {
		$0 = $1 " BLOAD \"tengu.bin\":EXEC &HD386:EXEC &HD389:IF PEEK(&HDFFF)=255 THEN 12000"
	}
	if ($1 == 5020) {
		$0 = $1 " XC=0:ON ERROR GOTO 60000"
	}
	if ($1 == 5021) {
		$0 = $0 "#1"
	}
	if ($1 == 5030) {
		$0 = $1 " CLEAR 3000,&HB900:BM=PEEK(&HDFFD):ON ERROR GOTO 60000"
	}
	if ($1 == 5040) {
		$0 = $1 " WS=PEEK(&HD100)+256*PEEK(&HD101)"
	}
	if ($1 == 5045) {
		sub(/EPASS/,"EP")
		sub(/SEL/,"SE")
		sub(/H8583/,"HD706")
		sub(/H8586/,"HD70B")
	}
	if ($1 == 5050) {
		$0 = $1 " BLOAD \"MSK4\":POKE &HD398,&H57:POKE &HD399,&H10:EXEC &HD383"
	}
	if ($1 == 5051) {
		$0 = $1 " BX=0:GX=0"
	}
	if ($1 == 5110) {
		sub(/GS\(255\),SS\(255\)/,"GS(176),SS(88)")
	}
	if ($1 == 5170 || $1 == 5180) {
		sub(/GET/,"WINDOW ")
		sub(/,2$/,":WINDOW 0")
	}
	if ($1 == 5171) {
		sub(/255/,"176")
		sub(/CVI\(INPUT\$\(2,2\)\)/,"WINDOW(I*2)+256*WINDOW(I*2+1)")
	}
	if ($1 == 5181) {
		sub(/255/,"88")
		sub(/CVI\(INPUT\$\(2,1\)\)/,"WINDOW(I*2)+256*WINDOW(I*2+1)")
	}
	if ($1 == 5184) {
		$0 = $1 " REM"
	}
	if ($1 == 5182) {
		$0 = $1 " SCREEN 2,2,2:CLS:OUT &H93,2"
	}
	if ($1 == 5183) {
		sub(/$/,":OUT \\&H93,3")
	}
	if ($1 == 5185) {
		$0 = $1 " IF KEY(0)<>0 THEN 5188"
	}
	if ($1 == 5186) {
		$0 = $1 " IF I>1000 THEN 5188"
	}
	if ($1 == 5187) {
		$0 = $1 " I=I+1:A=RND(1):GOTO 5185"
	}
	if ($1 == 5188) {
		sub(/CLS.* ,2:/,"")
		sub(/:SCR.*/,"")
	}
	if ($1 == 6510) {
		sub(/POKE.*CLOSE/,"CLOSE")
	}
	if ($1 == 6550) {
		$0 = $0 ":CLOSE #2"
	}
	if ($1 == 6560) {
		$0 = $1 " REM"
	}
	if ($1 == 6600) {
		gsub(/:GOTO/,":EXEC \\&H0123&")
	}
	if ($1 == 6610) {
		$0 = $1 " PK=KEY(0):A=RND(1)"
	}
	if ($1 == 6620) {
		gsub(/IF PK AND 1/,"IF PK=30")
	}
	if ($1 == 6630) {
		gsub(/IF PK AND 2/,"IF PK=31")
	}
	if ($1 == 6640) {
		$0 = $1 "  IF PK=13 OR PK=32 THEN RETURN"
	}
	if ($1 == 7600 || $1 == 7610 || $1 == 7620) {
		sub(/DATA /,"DATA")
	}
	if ($1 == 9030 || $1 == 9040) {
		$0 = $1 " REM"
	}
	if ($1 == 30040) {
		$0 = $1 " EXEC &HDF09"
	}
	if ($1 == 30070) {
		$0 = $1 " EXEC &HDF03:EXEC &HDF06"
	}
	if ($1 == 60050) {
		$0 = $1 " SCREEN 2,2,2:CONSOLE 0,20,0,0"
	}
	if ($1 == 60060) {
		$0 = $1 " IF PEEK(&HDFFE)=0 THEN 60065"
	}
	if ($1 == 60070) {
		sub(/ZX.*PRINT/,"LOCATE10,12:PRINT")
	}
	if ($1 == 60080) {
		$0 = $1 " LOCATE 10,14:PRINT\"     Hit any key     \":EXEC &H0123"
	}
	if ($1 == 60090) {
		sub(/POKE.*&HC9:/,"")
	}


# x̋LƃRgAEg
	if ( substr($2,1,1) == "*") {
		match($0,/ /)
		tmp1 = substr($0,RSTART+2)
		if ( match(tmp1,/:/) == 0) {
			tmp2 = "'"
			tmp3 = tmp1
		} else {
			tmp2 = substr(tmp1,RSTART+1)
			tmp3 = substr(tmp1,1,RSTART-1)
		}
		$0 = $1 " "tmp2
		gsub(/\./,"\\.",tmp3)
		label[labelcnt] = "\\*" tmp3
		labelnum[labelcnt] = $1
		labelcnt ++
	}


	linebuf[linecnt] = $0
	linecnt ++

}

END {
	wflag = 0
	for (i = 1;i < linecnt;) {
		for (j = 1;j < labelcnt;j ++) {
			gsub(label[j],labelnum[j],linebuf[i])
		}

# WHILE - WEND 

		match(linebuf[i+1],/[^0-9 ]/)
		n_num = substr(linebuf[i+1],1,RSTART-1)

		match(linebuf[i]  ,/[^0-9 ]/)
		c_num = substr(linebuf[i],1,RSTART-1)
		c_line = substr(linebuf[i],RSTART)

		c_if = match(c_line,/IF/)
		c_wl = match(c_line,/WHILE/)
		c_wd = match(c_line,/WEND/)

		match(c_line,/[ :]*WHILE/)
		c_b_wl = substr(c_line,1,RSTART-1)

		match(c_line,/WHILE */)
		c_x_wl = substr(c_line,RSTART+RLENGTH)
		if (match(c_x_wl,/ *:/) != 0) {
			c_x_wl = substr(c_x_wl,1,RSTART-1)
		}

		if (match(c_line,/WHILE *[^:]*:/) == 0) {
			c_e_wl = ""
		} else {
			c_e_wl = substr(c_line,RSTART+RLENGTH)
		}

		match(c_line,/WHILE *[^:]*:/)
		c_m_wl = substr(c_line,RSTART+RLENGTH)
		match(c_m_wl,/[ :]*WEND/)
		c_m_wl = substr(c_m_wl,1,RSTART-1)

		match(c_line,/[ :]*WEND[ :]*/)
		c_e_wd = substr(c_line,RSTART+RLENGTH)

		match(c_line,/[ :]*WEND/)
		c_b_wd = substr(c_line,1,RSTART-1)


		if (c_wl != 0) {
			if (c_if != 0 && c_if < c_wl) {
				print "Error!! IF before WHILE"
				print linebuf[i]
			} else {
				if (c_wd != 0) {
					if (n_num-c_num < 5) {
						print "Error!! LineNumber"
						print linebuf[i]
						print linebuf[i+1]
					} else {
						if (c_b_wl == "") {
							c_b_wl = "'"
						}
						if (c_e_wd == "") {
							c_e_wd = "'"
						}
						print c_num+0 " " c_b_wl
						print c_num+1 " " "IF " c_x_wl " THEN " c_num+3
						print c_num+2 " " "GOTO " c_num+4
						print c_num+3 " " c_m_wl ":GOTO " c_num+1
						print c_num+4 " " c_e_wd
					}
				} else {

					wflag = c_num+1
					if (n_num-c_num < 4) {
						print "Error!! LineNumber"
						print linebuf[i]
						print linebuf[i+1]
					} else {

						w_num = c_num

						i ++
						for (j = 1;c_wd == 0;j++) {
							wbuf[j] = linebuf[i]
							c_wd = match(wbuf[j],/WEND/)
							i ++
						}
						j --
						i --

						match(linebuf[i+1],/[^0-9 ]/)
						n_num = substr(linebuf[i+1],1,RSTART-1)

						match(linebuf[i]  ,/[^0-9 ]/)
						c_num = substr(linebuf[i],1,RSTART-1)
						c_line = substr(linebuf[i],RSTART)


						if (c_b_wl == "") {
							c_b_wl = "'"
						}
						if (c_e_wl == "") {
							c_e_wl = "'"
						}
						print w_num+0 " " c_b_wl
						print w_num+1 " " "IF " c_x_wl " THEN " w_num+3
						print w_num+2 " " "GOTO " c_num+1
						print w_num+3 " " c_e_wl

						for (k = 1;k < j;k ++) {
							print wbuf[k]
						}

						match(c_line,/[ :]*WEND[ :]*/)
						c_e_wd = substr(c_line,RSTART+RLENGTH)

						match(c_line,/[ :]*WEND/)
						c_b_wd = substr(c_line,1,RSTART-1)

						if (n_num-c_num < 2) {
							print "Error!! LineNumber"
							print wbuf[j]
							print wbuf[j+1]
						} else {
							if (c_e_wd == "") {
								c_e_wd = "'"
							}
							print c_num+0 " " c_b_wd ":GOTO " wflag
							print c_num+1 " " c_e_wd
							wflag = 0
						}

					}

				}
			}

		} else {
			print linebuf[i]
		}

		if (match(linebuf[i],/^5001 /) != 0) {
			print "5002 WIDTH 40,20:CONSOLE 0,20,0,0:CLS:PRINT \"Now Loading...\""
		}

		if (match(linebuf[i],/^5010 /) != 0) {
			print "5011 SCREEN 2,2,2:CONSOLE 0,20,0,0:CLS:EXEC &HD000:EXEC &HD700:EXEC &HDD00"
			print "5012 IF PEEK(&HDFFF)=0 THEN GOSUB 12100 ELSE GOSUB 12200"
			print "5013 POKE &HDFFD,BM:IF BM=1 THEN BLOAD \"nm4all\":EXEC &HDF00"
		}

		if (match(linebuf[i],/^5045 /) != 0) {
			print "5046 BLOAD \"MSK1\":POKE &HD398,&H00:POKE &HD399,&H20:EXEC &HD383"
			print "5047 BLOAD \"MSK2\":POKE &HD398,&H20:POKE &HD399,&H20:EXEC &HD383"
			print "5048 IF PEEK(&HDFFF)=0 THEN BLOAD \"MSK3\",&HB900:BLOAD \"MSK4\",&HF000:GOTO 5051"
			print "5049 BLOAD \"MSK3\":POKE &HD398,&H40:POKE &HD399,&H17:EXEC &HD383"
		}

		if (match(linebuf[i],/^9930 /) != 0) {
			print "10000 POKE &HEC7C,2:POKE &HECA0,80:LOCATE ZX,ZY:POKE &HEC7C,1:POKE &HECA0,40:RETURN"
			print "11000 EXEC &H0123"
			print "11010 IF KEY(0)=0 THEN 11010"
			print "11020 IF KEY(0)<>0 THEN 11020"
			print "11030 RETURN"
			print "12000 SCREEN 1,1,1:A$=\" RAM  Ͼݡ\":GOSUB 12050"
			print "12010 A$=\"16K  64K   RAM  ¹ø޻\":GOSUB 12050"
			print "12020 GOTO 12020"
			print "12050 FOR I=1 TO LEN(A$):B=ASC(MID$(A$,I,1))"
			print "12060 IF B>=&HA6 AND B<=&HBF THEN B=B-&H20"
			print "12070 IF B>=&HC0 AND B<=&HDD THEN B=B+&H20"
			print "12080 PRINT CHR$(B);:NEXT"
			print "12090 PRINT:RETURN"
			print "12100 A$=\"RAM  16K  BGM  ׼Ͼݡ\":GOSUB 12050"
			print "12110 A$=\"HIT SPACE KEY\":GOSUB 12050"
			print "12120 GOSUB 11000:BM=0:RETURN"
			print "12200 A$=\"BGM  ׼Ͻ? (y/n)\":GOSUB 12050:EXEC &H0123"
			print "12210 KK=KEY(0)"
			print "12220 IF KK=&H79 THEN BM=1:RETURN"
			print "12230 IF KK=&H6E THEN BM=0:RETURN"
			print "12240 GOTO 12210"
			print "12300 IF PEEK(&HDFFE)=0 THEN RETURN"
			print "12310 CHAIN 2,\"TENGUP6\"+CHR$(65+DK):RETURN"

		}

		if (match(linebuf[i],/^60050 /) != 0) {
			print "60051 CLS:PRINT:COLOR 16"
			print "60052 VIEW\"G[ԍF\":VIEW STR$(ERR):VIEW STR$(ERL):PRINT"
			print "60055 GOTO 60055"
		}

		if (match(linebuf[i],/^60060 /) != 0) {
			print "60061 XC=XC+1:IF XC=2 THEN 60065"
			print "60062 CHAIN 2,\"TENGUP6B\":GOTO 60090"
			print "60065 XC=0:CLS:LOCATE10,10:PRINT\"Drive 2 is disk error\""
		}

		if (match(linebuf[i],/^60080 /) != 0) {
			print "60081 IF INKEY$=\"\" THEN 60081"
			print "60082 IF INKEY$<>\"\" THEN 60082"
		}

		i ++

	}

}
